/* This plugin contains commands specific for the Counterstrike mod 
 * Original plugin_CS.sma by darope, updated for individual bans */

/* $Id: plugin_CS_indiv.sma,v 1.3 2001/04/09 yensid Exp $ */

/* Restart round voting by Nathan O'Sullivan */

/* Weapon restriction by GIJoe (CSController@yahoo.com) */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_VOTE_RESTART 1
#define ACCESS_RESTART 2
#define ACCESS_CHANGE_TEAM 8192
#define ACCESS_RESTRICT 8192

#define ITEM_INVALID -1

#define MAX_MENU_CHOICES 10
#define MAX_MENUS 10

#define MENU_INVALID -1
#define MENU_TOP 0

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.0";

new UserMenu[MAX_PLAYERS];
new RestrictMenu1[MAX_MENU_CHOICES][MAX_PLAYERS];
new RestrictMenu2[MAX_MENU_CHOICES][MAX_PLAYERS];
new RestrictMenu3[MAX_MENU_CHOICES][MAX_PLAYERS];
new RestrictMenu4[MAX_MENU_CHOICES][MAX_PLAYERS];
new RestrictMenu5[MAX_MENU_CHOICES][MAX_PLAYERS];
new RestrictMenu8[MAX_MENU_CHOICES][MAX_PLAYERS];

AllowAllWeapons(AllowWeapon) {
	new i;
	new j;
	
	for(i=0;i<MAX_MENU_CHOICES;i++)
		for(j=0;j<MAX_PLAYERS;j++) {
			RestrictMenu1[i][j]=AllowWeapon;
			RestrictMenu2[i][j]=AllowWeapon;
			RestrictMenu3[i][j]=AllowWeapon;
			RestrictMenu4[i][j]=AllowWeapon;
			RestrictMenu5[i][j]=AllowWeapon;
			RestrictMenu8[i][j]=AllowWeapon;
		}
}

AllowAllWeaponsIndiv(AllowWeapon,iIndex) {
	new i;
	
	for(i=0;i<MAX_MENU_CHOICES;i++) {
		RestrictMenu1[i][iIndex]=AllowWeapon;
		RestrictMenu2[i][iIndex]=AllowWeapon;
		RestrictMenu3[i][iIndex]=AllowWeapon;
		RestrictMenu4[i][iIndex]=AllowWeapon;
		RestrictMenu5[i][iIndex]=AllowWeapon;
		RestrictMenu8[i][iIndex]=AllowWeapon;
	}
}

AllowMenu(Menu,AllowWeapon) {
	new i;
	new j;
	
	for(i=0;i<MAX_MENU_CHOICES;i++)
		for(j=0;j<MAX_PLAYERS;j++) {
			if (Menu==1){
				RestrictMenu1[i][j]=AllowWeapon;
			} else if (Menu==2) {
				RestrictMenu2[i][j]=AllowWeapon;
			} else if (Menu==3) {
				RestrictMenu3[i][j]=AllowWeapon;
			} else if (Menu==4) {
				RestrictMenu4[i][j]=AllowWeapon;
			} else if (Menu==5) {
				RestrictMenu5[i][j]=AllowWeapon;
			} else if (Menu==8) {
				RestrictMenu8[i][j]=AllowWeapon;
			}
		}
}

AllowMenuIndiv(Menu,AllowWeapon,iIndex) {
	new i;
	
	for(i=0;i<MAX_MENU_CHOICES;i++) {
		if (Menu==1){
			RestrictMenu1[i][iIndex]=AllowWeapon;
		} else if (Menu==2) {
			RestrictMenu2[i][iIndex]=AllowWeapon;
		} else if (Menu==3) {
			RestrictMenu3[i][iIndex]=AllowWeapon;
		} else if (Menu==4) {
			RestrictMenu4[i][iIndex]=AllowWeapon;
		} else if (Menu==5) {
			RestrictMenu5[i][iIndex]=AllowWeapon;
		} else if (Menu==8) {
			RestrictMenu8[i][iIndex]=AllowWeapon;
		}
	}
}

AllowWeapon(Menu,Weapon,AllowWeapon) {
	new i;
	
	for(i=0;i<MAX_PLAYERS;i++) {
		if (Menu==1){
			RestrictMenu1[Weapon][i]=AllowWeapon;
		} else if (Menu==2) {
			RestrictMenu2[Weapon][i]=AllowWeapon;
		} else if (Menu==3) {
			RestrictMenu3[Weapon][i]=AllowWeapon;
		} else if (Menu==4) {
			RestrictMenu4[Weapon][i]=AllowWeapon;
		} else if (Menu==5) {
			RestrictMenu5[Weapon][i]=AllowWeapon;
		} else if (Menu==8) {
			RestrictMenu8[Weapon][i]=AllowWeapon;
		}
	}
}

AllowWeaponIndiv(Menu,Weapon,AllowWeapon,iIndex) {
	if (Menu==1){
		RestrictMenu1[Weapon][iIndex]=AllowWeapon;
	} else if (Menu==2) {
		RestrictMenu2[Weapon][iIndex]=AllowWeapon;
	} else if (Menu==3) {
		RestrictMenu3[Weapon][iIndex]=AllowWeapon;
	} else if (Menu==4) {
		RestrictMenu4[Weapon][iIndex]=AllowWeapon;
	} else if (Menu==5) {
		RestrictMenu5[Weapon][iIndex]=AllowWeapon;
	} else if (Menu==8) {
		RestrictMenu8[Weapon][iIndex]=AllowWeapon;
	}
}

public admin_changeteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
		
	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if (check_user(Data) == 1) {
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		say_command(User,Command,TargetName);
		if (check_immunity(TargetName) != 0) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't move %s onto another team, you silly bear.", TargetName);
			say(Text);
		} else if (streq(Command,"admin_ct")==1) {
			execclient(TargetName, "chooseteam;menuselect 2;menuselect 3"); 
		} else if (streq(Command,"admin_t")==1) {
			execclient(TargetName, "chooseteam;menuselect 1;menuselect 3"); 
		}
	} else {
		selfmessage("Unrecognized player: ");
		selfmessage(Data);
	}

	return PLUGIN_HANDLED;
}

/* Weapon restriction commands by GIJoe. Usage:

admin_allowweapon <menu number> <weapon number>
admin_restrictweapon <menu number> <weapon number>

<menu number> = Number of menu weapon is in.
<weapon number> = Number of weapon to be restricted.

Ex,

admin_restrictweapon 1 2  would disallow anyone to purchase the number 2 pistol.
admin_allowweapon 1 2 would allow anyone to purchase the number 2 pistol

admin_allowmenu <menu>
admin_restrictmenu <menu>

admin_allowallweapons
admin_restrictallweapons

*/
public admin_handleall(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Cmd[MAX_DATA_LENGTH];
	new iIndex;
	new Text[MAX_TEXT_LENGTH];
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data, Target, Cmd, MAX_DATA_LENGTH);
	if (strlen(Cmd)==0) {
		if (streq(Command, "admin_enableallweapons")==1) {
			AllowAllWeapons(1);
			selfmessage("Enabling all weapons purchases.");
		} else {
			AllowAllWeapons(0);
			selfmessage("Restricting all weapons purchases.");
		}
	} else if(check_user(Target)==0) {
		selfmessage( "Unrecognized player: ");
		selfmessage( Target);
		return PLUGIN_HANDLED;
	} else {
		get_userindex(Target,iIndex);
		get_username(Target,TargetName,MAX_NAME_LENGTH);
		if (streq(Command, "admin_enableallweapons")==1) {
			AllowAllWeaponsIndiv(1, iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Enabling weapons purchases for %s.", TargetName);
			selfmessage(Text);
		} else {
			AllowAllWeaponsIndiv(0, iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Restricting weapons purchases for %s.", TargetName);
			selfmessage(Text);
		}
	}
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

public admin_handleequip(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new iIndex;
	new Text[MAX_TEXT_LENGTH];
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if (strlen(Data)==0) {
		if (streq(Command, "admin_enableequipment")==1) {
			AllowMenu(8,1);
			selfmessage("Enabling equipment purchases.");
		} else {
			AllowMenu(8,0);
			selfmessage("Restricting equipment purchases.");
		}
	} else if(check_user(Data)==0) {
		selfmessage("Unrecognized player: ");
		selfmessage(Data);
		return PLUGIN_HANDLED;
	} else {
		get_userindex(Data, iIndex);
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		if (streq(Command, "admin_enableequipment")==1) {
			AllowMenuIndiv(8,1,iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Enabling equipment purchases for %s.", TargetName);
			selfmessage(Text);
		} else {
			AllowMenuIndiv(8,0,iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Restricting equipment purchases for %s.", TargetName);
			selfmessage(Text);
		}
	} 
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

public admin_handlemenu(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iMenu;
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Cmd[MAX_DATA_LENGTH];
	new iIndex;
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data, Target, Cmd, MAX_DATA_LENGTH);
	if (strlen(Cmd)==0) {
		iMenu = strtonum(Data);
		if(iMenu <= 0 || iMenu >= MAX_MENUS) {
			selfmessage( "Invalid menu number.");
			return PLUGIN_HANDLED;
		} else if (streq(Command, "admin_enablemenu")==1) {
			AllowMenu(iMenu,1);
			snprintf(Text, MAX_TEXT_LENGTH, "Enabling menu %s.", Data);
			selfmessage(Text);
		} else {
			AllowMenu(iMenu,0);
			snprintf(Text, MAX_TEXT_LENGTH, "Restricting menu %s.", Data);
			selfmessage(Text);
		}
	} else if(check_user(Target)==0) {
		selfmessage( "Unrecognized player: ");
		selfmessage( Target);
		return PLUGIN_HANDLED;
	} else {
		get_userindex(Target, iIndex);
		get_username(Target,TargetName,MAX_NAME_LENGTH);
		iMenu = strtonum(Cmd);
		if(iMenu <= 0 || iMenu >= MAX_MENUS) {
			selfmessage( "Invalid menu number.");
			return PLUGIN_HANDLED;
		} else if (streq(Command, "admin_enablemenu")==1) {
			AllowMenuIndiv(iMenu,1,iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Enabling menu %s for %s.", Cmd, TargetName);
			selfmessage(Text);
		} else {
			AllowMenuIndiv(iMenu,0,iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Restricting menu %s for %s.", Cmd, TargetName);
			selfmessage(Text);
		}
	} 
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

public admin_handleweapon(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iItem;
	new iMenu;
	new strItem[MAX_DATA_LENGTH];
	new strMenu[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Cmd[MAX_DATA_LENGTH];
	new iIndex;

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data, Target, Cmd, MAX_DATA_LENGTH);
	strbreak(Cmd, strMenu, strItem, MAX_DATA_LENGTH);
	if (strlen(strItem)==0) {
		strbreak(Data, strMenu, strItem, MAX_DATA_LENGTH);
		iItem = strtonum(strItem);
		iMenu = strtonum(strMenu);
		if(iMenu <= 0 || iMenu >= MAX_MENUS) {
			selfmessage( "Invalid menu number.");
			return PLUGIN_HANDLED;
		} else if (iItem <= 0 || iItem >= MAX_MENU_CHOICES) {
			selfmessage( "Invalid item number.");
			return PLUGIN_HANDLED;
		} else if (streq(Command, "admin_enableweapon")==1) {
			AllowWeapon(iMenu,iItem,1);
			snprintf(Text, MAX_TEXT_LENGTH, "Enabling weapon %s.", Data);
			selfmessage(Text);
		} else {
			AllowWeapon(iMenu,iItem,0);
			snprintf(Text, MAX_TEXT_LENGTH, "Restricting weapon %s.", Data);
			selfmessage(Text);
		}
	} else if(check_user(Target)==0) {
		selfmessage( "Unrecognized player: ");
		selfmessage( Target);
		return PLUGIN_HANDLED;
	} else {
		get_userindex(Target, iIndex);
		get_username(Target,TargetName,MAX_NAME_LENGTH);
		iItem = strtonum(strItem);
		iMenu = strtonum(strMenu);
		if(iMenu <= 0 || iMenu >= MAX_MENUS) {
			selfmessage( "Invalid menu number.");
			return PLUGIN_HANDLED;
		} else if (iItem <= 0 || iItem >= MAX_MENU_CHOICES) {
			selfmessage( "Invalid item number.");
			return PLUGIN_HANDLED;
		} else if (streq(Command, "admin_enableweapon")==1) {
			AllowWeaponIndiv(iMenu,iItem,1,iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Enabling weapon %s for %s.", Cmd, TargetName);
			selfmessage(Text);
		} else {
			AllowWeaponIndiv(iMenu,iItem,0,iIndex);
			snprintf(Text, MAX_TEXT_LENGTH, "Restricting weapon %s for %s.", Cmd, TargetName);
			selfmessage(Text);
		}
	} 
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

public admin_restartround(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	execute_command(User,Command,"sv_restartround",Data);
	return PLUGIN_HANDLED;
}

/* Restart vote by Nathan O'Sullivan */
public admin_vote_restart(HLCommand,HLData,HLUserName,UserIndex) {
	new unused[MAX_NAME_LENGTH];
	
	if (vote_allowed()!=1) {
		selfmessage( "Vote not allowed at this time.");
		return PLUGIN_HANDLED;
	}

	vote("Restart map & begin play?","Yes","No","restart_vote",unused);
	return PLUGIN_HANDLED;
}

public restart_vote(a,b,c,d) {
	new Text[MAX_TEXT_LENGTH];
	
	if ( a == 1 ) {
		new ratio = getvar("map_ratio");
		if ( ratio == 0 ) {
			say("Restart vote is not enabled");
			return;
		}
		if ( c > (ratio/100)*d ) {
			new tleft, tlimit;
			tleft = timeleft() - 10; // # seconds till restart!
			tlimit = getvar("mp_timelimit");
			tlimit = tlimit + (tlimit - tleft/60);
			
			snprintf(Text, MAX_TEXT_LENGTH, "mp_timelimit %i", tlimit);
			exec(Text);
			exec ("sv_restartround 10");
		} else {
			say("Not enough votes for map restart");
		}
	} else {
		say("Not enough votes for map restart");
	}
}

public admin_weaponscheck(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(check_param(Data)==1) {
		execute_command(User,Command,"admin_cs_restrict","1");
	} else {
		execute_command(User,Command,"admin_cs_restrict","0");
	}
	return PLUGIN_HANDLED;
}

public ClearMenuData(HLCommand,HLData,HLUserName,UserIndex) {
	if (getvar("admin_cs_restrict")==1) {
		UserMenu[UserIndex] = MENU_INVALID;
	}
	return PLUGIN_CONTINUE;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	
	if (getvar("admin_cs_restrict")==1) {
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		if (streq(Command, "buyequip")==1) {
			UserMenu[UserIndex] = 8;
		} else if (streq(Command, "buy")==1) {
			UserMenu[UserIndex] = MENU_TOP;
		/* Sank's showbriefing fix */
		} else if (streq(Command, "showbriefing")==1) {
			if (UserMenu[UserIndex] == MENU_INVALID) {
				UserMenu[UserIndex] = 1;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public SetSelectData(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iMenu;

	if (getvar("admin_cs_restrict")==1) {
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);

		iMenu = UserMenu[UserIndex];
		/* If they're at the top menu, look at the data and set that as their new menu.
		6, 7, and 10 are exceptions, because those exit the menu process. For them, set
		them at no menu. */
		if (iMenu == MENU_TOP) {
			new iNewMenu = strtonum(Data);
			if (iNewMenu == 6 || iNewMenu == 7 || iNewMenu == 10) {
				UserMenu[UserIndex] = MENU_INVALID;
			} else {
				UserMenu[UserIndex] = iNewMenu;
			}
		/* Otherwise, check to see if we should allow their purchase to happen.  If so,
		happy days...otherwise, eat the message and reset their menu level. */
		} else if (iMenu > MENU_INVALID) {
			new iNewItem = strtonum(Data);
			
			if (iNewItem==10) {
				UserMenu[UserIndex] = MENU_INVALID;
			} else if (iMenu==1) {
				if (RestrictMenu1[iNewItem][UserIndex]==0) {
					messageex(User, "Server currently does not allow that.", print_center);
					/* Sank's showbriefing fix. 
					UserMenu[UserIndex] = MENU_INVALID;
					
					Instead of setting UserMenu just to negative 1,
					negate UserMenu so that the showbriefing intercept works */
					UserMenu[UserIndex] = -UserMenu[UserIndex];
					return PLUGIN_HANDLED;
				} else {
					UserMenu[UserIndex] = MENU_INVALID;
				}
			} else if (iMenu==2) {
				if (RestrictMenu2[iNewItem][UserIndex]==0) {
					messageex(User, "Server currently does not allow that.", print_center);
					/* Sank's showbriefing fix. 
					UserMenu[UserIndex] = MENU_INVALID;
					
					Instead of setting UserMenu just to negative 1,
					negate UserMenu so that the showbriefing intercept works */
					UserMenu[UserIndex] = -UserMenu[UserIndex];
					return PLUGIN_HANDLED;
				} else {
					UserMenu[UserIndex] = MENU_INVALID;
				}
			} else if (iMenu==3) {
				if (RestrictMenu4[iNewItem][UserIndex]==0) {
					messageex(User, "Server currently does not allow that.", print_center);
					/* Sank's showbriefing fix. 
					UserMenu[UserIndex] = MENU_INVALID;
					
					Instead of setting UserMenu just to negative 1,
					negate UserMenu so that the showbriefing intercept works */
					UserMenu[UserIndex] = -UserMenu[UserIndex];
					return PLUGIN_HANDLED;
				} else {
					UserMenu[UserIndex] = MENU_INVALID;
				}
			} else if (iMenu==4) {
				if (RestrictMenu4[iNewItem][UserIndex]==0) {
					messageex(User, "Server currently does not allow that.", print_center);
					/* Sank's showbriefing fix. 
					UserMenu[UserIndex] = MENU_INVALID;
					
					Instead of setting UserMenu just to negative 1,
					negate UserMenu so that the showbriefing intercept works */
					UserMenu[UserIndex] = -UserMenu[UserIndex];
					return PLUGIN_HANDLED;
				} else {
					UserMenu[UserIndex] = MENU_INVALID;
				}
			} else if (iMenu==5) {
				if (RestrictMenu5[iNewItem][UserIndex]==0) {
					messageex(User, "Server currently does not allow that.", print_center);
					/* Sank's showbriefing fix. 
					UserMenu[UserIndex] = MENU_INVALID;
					
					Instead of setting UserMenu just to negative 1,
					negate UserMenu so that the showbriefing intercept works */
					UserMenu[UserIndex] = -UserMenu[UserIndex];
					return PLUGIN_HANDLED;
				} else {
					UserMenu[UserIndex] = MENU_INVALID;
				}
			} else if (iMenu==8) {
				if (RestrictMenu8[iNewItem][UserIndex]==0) {
					messageex(User, "Server currently does not allow that.", print_center);
					/* Sank's showbriefing fix. 
					UserMenu[UserIndex] = MENU_INVALID;
					
					Instead of setting UserMenu just to negative 1,
					negate UserMenu so that the showbriefing intercept works */
					UserMenu[UserIndex] = -UserMenu[UserIndex];
					return PLUGIN_HANDLED;
				} else {
					UserMenu[UserIndex] = MENU_INVALID;
				}
			}
		} else if (iMenu < MENU_INVALID) {
			/* Sank's showbriefing fix 
			Only Showbriefing or some other menu-bypassing method should get in here */
			new iNewItem = strtonum(Data);
			
			if(0-iMenu==1) {
				if(RestrictMenu1[iNewItem][UserIndex] == 0)
				{
					messageex(User, "Server currently does not allow that.", print_center);
					return PLUGIN_HANDLED;
				}
			} else 	if(0-iMenu==2) {
				if(RestrictMenu2[iNewItem][UserIndex] == 0)
				{
					messageex(User, "Server currently does not allow that.", print_center);
					return PLUGIN_HANDLED;
				}
			} else 	if(0-iMenu==3) {
				if(RestrictMenu3[iNewItem][UserIndex] == 0)
				{
					messageex(User, "Server currently does not allow that.", print_center);
					return PLUGIN_HANDLED;
				}
			} else 	if(0-iMenu==4) {
				if(RestrictMenu4[iNewItem][UserIndex] == 0)
				{
					messageex(User, "Server currently does not allow that.", print_center);
					return PLUGIN_HANDLED;
				}
			} else 	if(0-iMenu==5) {
				if(RestrictMenu5[iNewItem][UserIndex] == 0)
				{
					messageex(User, "Server currently does not allow that.", print_center);
					return PLUGIN_HANDLED;
				}
			} else 	if(0-iMenu==8) {
				if(RestrictMenu8[iNewItem][UserIndex] == 0)
				{
					messageex(User, "Server currently does not allow that.", print_center);
					return PLUGIN_HANDLED;
				}
			}
		} else {
			UserMenu[UserIndex] = MENU_INVALID;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserMenu[UserIndex] = MENU_INVALID;
		new i;
		
		for(i=0;i<MAX_MENU_CHOICES;i++) {
			RestrictMenu1[i][UserIndex]=1;
			RestrictMenu2[i][UserIndex]=1;
			RestrictMenu3[i][UserIndex]=1;
			RestrictMenu4[i][UserIndex]=1;
			RestrictMenu5[i][UserIndex]=1;
			RestrictMenu8[i][UserIndex]=1;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserMenu[UserIndex] = MENU_INVALID;
		new i;
		
		for(i=0;i<MAX_MENU_CHOICES;i++) {
			RestrictMenu1[i][UserIndex]=1;
			RestrictMenu2[i][UserIndex]=1;
			RestrictMenu3[i][UserIndex]=1;
			RestrictMenu4[i][UserIndex]=1;
			RestrictMenu5[i][UserIndex]=1;
			RestrictMenu8[i][UserIndex]=1;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("Admin Counterstrike Plugin","Commands specific to the Counterstrike mod.",STRING_VERSION);

	plugin_registercmd("admin_ct","admin_changeteam",ACCESS_CHANGE_TEAM,"admin_ct <target>: Changes target to the counter-terrorist team.");
	plugin_registercmd("admin_enableallweapons","admin_handleall",ACCESS_RESTRICT,"admin_enableallweapons <target>: Allows target, or if no target, anyone to buy anything.");
	plugin_registercmd("admin_enableequipment","admin_handleequip",ACCESS_RESTRICT,"admin_enableequipment <target>: Allows target, or if no target, anyone to buy any equipment.");
	plugin_registercmd("admin_enablemenu","admin_handlemenu",ACCESS_RESTRICT,"admin_enablemenu <target> <menu>: Allows target, or if no target, anyone to buy anything on the specified menu.");
	plugin_registercmd("admin_enableweapon","admin_handleweapon",ACCESS_RESTRICT,"admin_enableweapon <target> <menu> <item>: Allows target, or if no target, anyone to buy the specified item on the speciifed menu.");
	plugin_registercmd("admin_restartround","admin_restartround",ACCESS_RESTART,"admin_restart: Restarts the round.");
	plugin_registercmd("admin_restrictallweapons","admin_handleall",ACCESS_RESTRICT,"admin_restrictallweapons <target>: Forbids target, or if no target, anyone from buying anything.");
	plugin_registercmd("admin_restrictequipment","admin_handleequip",ACCESS_RESTRICT,"admin_restrictequipment <target>: Forbids target, or if no target, anyone from buying any equipment.");
	plugin_registercmd("admin_restrictmenu","admin_handlemenu",ACCESS_RESTRICT,"admin_restrictmenu <target> <menu>: Forbids target, or if no target, anyone from buying anything on the specified menu.");
	plugin_registercmd("admin_restrictweapon","admin_handleweapon",ACCESS_RESTRICT,"admin_restrictweapon <target> <menu> <item>: Forbids target, or if no target, anyone from buying the specified item on the specified menu.");
	plugin_registercmd("admin_t","admin_changeteam",ACCESS_CHANGE_TEAM,"admin_t <target>: Changes target to the terrorist team.");
	plugin_registercmd("admin_vote_restart","admin_vote_restart",ACCESS_VOTE_RESTART,"admin_vote_restart: Starts a vote to restart the round.");
	plugin_registercmd("admin_weaponscheck","admin_weaponscheck",ACCESS_RESTRICT,"admin_weaponscheck <^"on^" | ^"off^">: Toggles whether or not weapon restrictions are used.");
	plugin_registercmd("chooseteam","ClearMenuData",ACCESS_ALL);
	plugin_registercmd("radio","ClearMenuData",ACCESS_ALL);
	plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
	plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
	/* Sank's showbriefing fix */
	plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
	plugin_registercmd("menuselect","SetSelectData",ACCESS_ALL);
	
	AllowAllWeapons(1);
	
	return PLUGIN_CONTINUE;
}
